#. author : Roland Frank
#. project: taifon Android app
#. license: GPLv3, see https://gnu.org/licenses
#.
set qq [file dirname [info script]]
proc gcp {a b} {
	set la [string length $a]
	set lb [string length $b]
	if {$la<$lb} {
		return [cp $a $b $la]
	} else {
		return [cp $a $b $lb]
	}
}
proc cp {short long len} {
	set pl 0
	while {$pl<$len} {
		if {![string equal [string range $short $pl $pl] [string range $long $pl $pl]]} {
			incr pl -1
			break
		}
		incr pl
	}
	return [string range $short 0 $pl]
}
proc nextchar {act} {
	if {[string length $act]==0} {

		return [format %c 0]
	} else {
		scan $act %c i
		incr i
		if {$i<128} {
			return [format %c $i]
		} elseif {$i<65536} {
			return [subst \\u[format %04x $i]]
		} else {
			return [subst \\U[format %08x $i]]
		}
	}
}
proc nbr {x listname start len {slen 0}} {
	upvar $listname ll
	set dist [expr {$len-$start}]
	if {$dist<=0} {
		return $start
	} else {
		set end $len
		while {1} {
			if {$dist <=2} {
				for {set i $start} {$i<=$end} {incr i} {
					set s [string compare [lindex $ll $i] $x]
					if {$s>=0} {
						break
					}
				}
				return $i
			} else {
				set mid [expr {$dist/2}]
				incr mid $start
				set s [string compare [lindex $ll $mid] $x]
				if {$s<0} {
					set start [expr {$mid+1}]
				} elseif {$s>0} {
					set end [expr {$mid-1}]
				} else {
					set end [expr {$mid-1}]
				}
				set dist [expr {$end-$start}]
			}
		}
	}
}
proc json_string {s} {
	set x [string map [list { } \\\  \{ \\{ \} \\} \\ \\\\ \" \\\" \n \\n \r \\r \v \\v \$ \\$ ] $s]
	return $x
}

source $qq/y_lcp.tcl


proc sorted_file2tx {fname} {
	set fs [open $fname r]
	set sorted_data [split [read $fs] \n]
	close $fs
	set px [list {}]

	set outfile [file root $fname]
	append outfile .tx
	set fh [open $outfile w]
	fconfigure $fh -encoding utf-8


	set llen [llength $sorted_data]
	if {![string length [lindex $sorted_data end]]} {


		incr llen -1


	}
	set ::txlev 0
	set steps [list 0]
	set use 1
	set gcp [tx_list sorted_data 0 $llen $fh steps]

	if {[string length $gcp]} {
		if {[llength $sorted_data] == 1} {
			puts $fh [list {} \\r1\\v$gcp]
		} else {
			puts $fh [list {} \\r0\\v$gcp]
		}
	}


	catch {
		uca_trans [array names ::dchar] ;#unicode collation purpose
	}
	seek $fh -1 current
	chan truncate $fh [tell $fh]
	close $fh
}
