

#. Code written by Rani Fayez Ahmad (Superlinux)
#. Website: http://www.superlinux.net
#. //wiki.tcl-lang.org/38244



proc list_of_all_ascii_parts_a_unicode_string { arabic_string} {

set ascii_parts_list [list]
set length [string length $arabic_string]
    for {set i 0} {$i< $length} {incr i} {
        set start_of_ascii $i
        
        set end_of_ascii  $start_of_ascii 
        while {[string is ascii [
            string range $arabic_string $start_of_ascii $end_of_ascii]] ==  1
            && $i<$length}  {
          
                puts [
                    string range $arabic_string $start_of_ascii $end_of_ascii]
                incr i
                incr end_of_ascii 
        }
        
        incr end_of_ascii -1
        
        set ascii_part [
            string range $arabic_string $start_of_ascii $end_of_ascii]
        
        if {[string trim $ascii_part] ne {}} {
          set ascii_parts_list [
              linsert $ascii_parts_list end [list $ascii_part $start_of_ascii]]
        }
    }
    return $ascii_parts_list
}

    
proc render_arabic args {
    set  arabic_string [lindex $args 0]
    set  is_messageBox [lindex $args 1]


    set  words [split [string trim $arabic_string]]






    set count 0




    foreach word $words {
        if {[string is ascii $word]} {
            incr count
            continue
        } 
















        set original_word $word
        set sub_word [string range $word 0 end-1]






        
        set sub_word [ string map {\u0628 \ufe91} $sub_word] ;#ba2
        set sub_word [ string map {\u062A \ufe97} $sub_word] ;#Ta2
        set sub_word [ string map {\u062B \ufe9b} $sub_word] ;#thaa2
        set sub_word [ string map {\u062C \ufe9f} $sub_word] ;#Jeem
        set sub_word [ string map {\u062d \ufea3} $sub_word] ;#7aa2
        set sub_word [ string map {\u062e \ufeA7} $sub_word] ;#5aa2
        set sub_word [ string map {\u0633 \ufeb3} $sub_word] ;#seen
        set sub_word [ string map {\u0634 \ufeb7} $sub_word] ;#sheen
        set sub_word [ string map {\u0635 \ufebb} $sub_word] ;#SSaad
        set sub_word [ string map {\u0636 \ufebf} $sub_word] ;#DDhahd
        set sub_word [ string map {\u0637 \ufec3} $sub_word] ;#TTaa2
        set sub_word [ string map {\u0638 \ufec7} $sub_word] ;#tthaa2 Zah
        set sub_word [ string map {\u0639 \ufeCb} $sub_word] ;#3eyn
        set sub_word [ string map {\u063A \ufeCF} $sub_word] ;#ghyn
        set sub_word [ string map {\u0641 \ufeD3} $sub_word] ;#faa2
        set sub_word [ string map {\u0642 \ufeD7} $sub_word] ;#quaaf
        set sub_word [ string map {\u0643 \ufeDb} $sub_word] ;#kaaf
        set sub_word [ string map {\u0644 \ufedf} $sub_word] ;#lam
        set sub_word [ string map {\u0645 \ufee3} $sub_word] ;#meem
        set sub_word [ string map {\u0646 \ufee7} $sub_word] ;#noon
        set sub_word [ string map {\u0647 \ufeeb} $sub_word] ;#haa2
        set sub_word [ string map {\u064A \ufef3} $sub_word] ;#yaa2
        set sub_word [ string map {\u0626 \ufe8b} $sub_word] ;#hamza 3ala nabera (initial form of yaa2)


        
        set word [string replace $word 0 end-1 $sub_word]


        set initials [list \u0640 \ufe90 \ufe97 \ufe9b \ufe9f \ufea3 \ufeA7 \
            \ufb3 \ufeb7 \ufebb \ufebf \ufec3 \ufec7 \ufeCb \ufeCF \ufeD3 \
            \ufeD7 \ufeDb \ufedf \ufee3 \ufee7 \ufeeb \ufef3]

        
        set before_last_char [string index $word end-1]







        if {[lsearch -ascii -inline $initials $before_last_char]
            eq $before_last_char} {

            set last_character [string index $word end]





            if {[string is ascii $last_character]} {
                set before_last_char [render_arabic $before_last_char]
            }





            switch -- $last_character {
                \u0628 {

                    set word [string replace $word end end \ufe90]
                }
                \u0629 {

                    set word [string replace $word end end \ufe94]
                }
                \u062A {

                    set word [string replace $word end end \ufe96]
                }
                \u062B {

                    set word [string replace $word end end \ufe9A]
                }
                \u062c {

                    set word [string replace $word end end \ufe9e]
                    puts $word
                }
                \u062d {

                    set word [string replace $word end end \ufeA2]
                }

                \u062e {

                    set word [string replace $word end end \ufea6]
                }

                \u062f {

                    set word [string replace $word end end \ufeaa]
                }

                \u0630 {

                    set word [string replace $word end end \ufeac]
                }
                \u0631 {

                    set word [string replace $word end end \ufeae]
                }
                \u0632 {

                    set word [string replace $word end end \ufeaf]
                }

                \u0633 {

                    set word [string replace $word end end \ufeb2]
                }
                \u0634 {

                    set word [string replace $word end end \ufeb6]
                }
                \u0635 {

                    set word [string replace $word end end \ufeba]
                }
                \u0636 {

                    set word [string replace $word end end \ufebe]
                }
                \u0637 {

                    set word [string replace $word end end \ufec2]
                }
                \u0638 {

                    set word [string replace $word end end \ufec8]
                }
                \u0639 {

                    set word [string replace $word end end \ufeca]
                }
                \u063a {

                    set word [string replace $word end end \ufece]
                }
                \u0641 {

                    set word [string replace $word end end \ufed2]
                }
                \u0642 {

                    set word [string replace $word end end \ufed6]
                }
                \u0643 {

                    set word [string replace $word end end \ufeda]
                }
                  \u0644 {

                    set word [ string replace $word end end \ufede ]
                }
                \u0645 {

                    set word [string replace $word end end \ufee2]
                }
                \u0646 {

                    set word [string replace $word end end \ufee6]
                }
                \u0647 {

                    set word [string replace $word end end \ufeea]
                }
                \u0648 {

                    set word [string replace $word end end \ufeee]
                }
                \u0624 {

                    set word [ string replace $word end end \ufe86]
                }
                \u0649 {

                    set word [string replace $word end end \ufef0]
                }
                \u064a {

                    set word [string replace $word end end \ufef1]
                }
                default {

                }
            }
     
        }





        set arabic_string [
            regsub -all "\\m$original_word\\M" $arabic_string $word]





        incr count
    }





    set arabic_string [string reverse $arabic_string]





    if { $is_messageBox ==1 } {
    foreach part [list_of_all_ascii_parts_a_unicode_string $arabic_string] {
        set part_string [string reverse [ lindex $part 0 ]]
        set start_of_ascii [ lindex $part 1 ]
        set length_part_string [string length $part_string]
        
        set arabic_string [string replace $arabic_string $start_of_ascii [expr $start_of_ascii + $length_part_string -1] $part_string]
      
    }
  }
  return $arabic_string 
}
if {0} {
	set ananas أناناس
	puts "split: [split $ananas]"
	set z [string reverse $ananas]
	append z " " [render_arabic $ananas]


	font configure TkDefaultFont -size 100
	puts $z

	package require Tk
	tk_messageBox -detail $z

	set schlange ثعبان
}
